<?php

namespace Drupal\bakery\Cookies;

use Drupal\bakery\BakeryService;
use Drupal\bakery\Kitchen;

trait BrowserCookieTrait {

  /**
   * Helper to determine if the current site is the "main" site.
   */
  protected function getIsMain(): bool {
    return static::getBakeryService()->isMain();
  }

  /**
   * Wrap cookie name for browser.
   */
  protected static function cookieName(string $type): string {
    return static::getBakeryKitchen()->cookieName($type);
  }

  /**
   * Get a bakery service.
   */
  private static function getBakeryService(): BakeryService {
    return \Drupal::service('bakery.bakery_service');
  }

  /**
   * Get a kitchen.
   */
  private static function getBakeryKitchen(): Kitchen {
    return \Drupal::service('bakery.kitchen');
  }

}
